// Peter Weigel

// charele    (class)
// charfield  (class)

package pefas.field;

class charele extends element {
  protected char value;                           // das eigentliche Element

  public charele(char value) {                    // Konstruktor
    this.value = value;                           // Integer-Wert bernehmen
  }

  public char value() {                           // Wert ermitteln
    return value;
  }

  public boolean lessthan(ielement ele) {          // Implementierung der abstrakten Methode
    return (this.value() < ((charele) ele).value());
  }

  public boolean equal(ielement ele) {             // Implementierung der abstrakten Methode
    return (this.value() == ((charele) ele).value());
  }

  public String toString() {                       // Implementierung der abstrakten Methode
    return new Character(value()).toString();
  }
}

public final class charfield extends field implements icharfield {

  public charfield(int n) {                  // Der Konstruktor bleibt der selbe
    super(n);
  }

  public void value(int i, char value) {     // Wert setzen
    item(i, new charele(value));             // Element erzeugen und weiterreichen.
  }

  public char value(int i) {                 // Wert ermitteln
    return ((charele) item(i)).value();      // Element holen und explizit als intele casten.
  }

  public void append(char value) {           // Feld vergrern und neuen Wert am Ende einfgen
    append(new charele(value));              // Element erzeugen und weiterreichen.
  }
}
