// Peter Weigel

// stringele    (class)
// stringfield  (class)

package pefas.field;

class stringele extends element {
  protected String value;                           // das eigentliche Element

  public stringele(String value) {                    // Konstruktor
    this.value = value;                           // Integer-Wert bernehmen
  }

  public String value() {                           // Wert ermitteln
    return value;
  }

  public boolean lessthan(ielement ele) {          // Implementierung der abstrakten Methode
    return (this.value().compareTo(((stringele) ele).value()) < 0);
  }

  public boolean equal(ielement ele) {             // Implementierung der abstrakten Methode
    return (this.value().compareTo(((stringele) ele).value()) == 0);
  }

  public String toString() {                       // Implementierung der abstrakten Methode
    return value();
  }
}

public final class stringfield extends field implements istringfield {

  public stringfield(int n) {                  // Der Konstruktor bleibt der selbe
    super(n);
  }

  public void value(int i, String value) {     // Wert setzen
    item(i, new stringele(value));             // Element erzeugen und weiterreichen.
  }

  public String value(int i) {                 // Wert ermitteln
    return ((stringele) item(i)).value();      // Element holen und explizit als intele casten.
  }

  public void append(String value) {           // Feld vergrern und neuen Wert am Ende einfgen
    append(new stringele(value));              // Element erzeugen und weiterreichen.
  }
}
