// Peter Weigel

// Combsort
// Variante 3

package pefas.sort;

import pefas.field.ifield;

public class combsort3 extends sort {

  public void sort(ifield A, int l, int r) {
        int gap = r-l;
        do {
            if (gap > 1) {
              gap = (int) (gap / 1.3);
            }
        } while ((comb(A, l, r, gap)) || (gap > 1));
    }

  protected boolean comb(ifield A, int l, int r, int gap) {
    oet(A, l, r, gap);
    return oet(A, l+gap, r, gap);
  }

  protected boolean oet(ifield A, int l, int r, int gap) {
    boolean flipped= false;
    for (int i=l;i<=r-gap;i+=2*gap) {
      for (int j=i; (j <= (i+gap-1)) && (j<= (r-gap));j++) {
        if (A.gt(j,j+gap)) {
          A.exchange(j,j+gap);
          flipped = true;
        }
      }
    }
    return flipped;
  }

}
