// Peter Weigel

// Mergesort
// Variante 6+1

package pefas.sort;

import pefas.field.ifield;

public class mergesort16 extends sort {

  public void sort(ifield A, int l, int r) {
    int[][] B = new int[2][r+1];
    sort(A, B, l, r);
  }

  public void sort(ifield A, int[][] B, int l, int r) {
    if (l < r) {
      int q= (l+r)/2;
      sort(A, B, l, q);
      sort(A, B, q+1, r);
      merge(A, B, l, q, r);
    }
  }

  protected void merge(ifield A, int[][] B, int l, int q, int r) {      // Aufteilen eines Teilfeldes in zwei Teilfelder
    for (int i=l;i<=q;i++) {
      B[0][i] = i;
      B[1][i] = i;
    }
    for (int i=r;i>q;i--) {
      B[0][i] = r+q+1-i;
      B[1][i] = r+q+1-i;
    }
    int i= l;
    int j= r;
    for (int k=l; k<r;k++) {
      int s= B[0][i];
      int t= B[0][j];
      if (!A.gt(s, t)) {
        i++;
      } else {
        s= t;
        j--;
      }
      A.exchange(s, k);
      t= B[1][k];
      B[0][t]= s;
      B[1][s]= t;
    }
  }

}
