// Peter Weigel

// floatele    (class)
// floatfield  (class)

package pefas.field;

class floatele extends element {
  protected float value;                           // das eigentliche Element

  public floatele(float value) {                    // Konstruktor
    this.value = value;                           // Integer-Wert bernehmen
  }

  public float value() {                           // Wert ermitteln
    return value;
  }

  public boolean lessthan(ielement ele) {          // Implementierung der abstrakten Methode
    return (this.value() < ((floatele) ele).value());
  }

  public boolean equal(ielement ele) {             // Implementierung der abstrakten Methode
    return (this.value() == ((floatele) ele).value());
  }

  public String toString() {                       // Implementierung der abstrakten Methode
    return Float.toString(value());
  }
}

public final class floatfield extends field implements ifloatfield {

  public floatfield(int n) {                  // Der Konstruktor bleibt der selbe
    super(n);
  }

  public void value(int i, float value) {     // Wert setzen
    item(i, new floatele(value));             // Element erzeugen und weiterreichen.
  }

  public float value(int i) {                 // Wert ermitteln
    return ((floatele) item(i)).value();      // Element holen und explizit als intele casten.
  }

  public void append(float value) {           // Feld vergrern und neuen Wert am Ende einfgen
    append(new floatele(value));              // Element erzeugen und weiterreichen.
  }
}

