// Peter Weigel

// ielement (interface)

/*
  +-----------------------------------------------------------------------------------------+
  | Interface-Deklaration eines beliebigen unspezialisierten Feldelementes.                 |
  +------------+----------------------------------------------------------------------------+
  | name       | ielement                                                                   |
  | extends    |                                                                            |
  | implements |                                                                            |
  | type       | interface                                                                  |
  +------------+----------------------------------------------------------------------------+
  | public boolean lessthan(ielement ele);   // Vergleich auf echt kleiner                  |
  | public boolean equal(ielement ele);      // Vergleich auf Gleichheit                    |
  | public String  toString();               // Wert als String zurckgeben                 |
  +-----------------------------------------------------------------------------------------+
*/

package pefas.field;

public interface ielement {
  public boolean lessthan(ielement ele);  // Vergleich auf echt kleiner.
  public boolean equal(ielement ele);     // Vergleich auf Gleichheit.
  public String  toString();              // Wert als String zurckgeben.
}

// Denkbar wre eine Implementierung als Objekt mit einem speziellen Element als Unterobjekt
// oder als Datensatz, der sich selbst als Element betrachten kann.

