// Peter Weigel

// Bitonic Mergesort
// Variante 2+5

package pefas.sort;

import pefas.field.ifield;

public class btmsort25 extends sort {

  public void sort(ifield A, int l, int r) {
    for (int m= 2; m<=r-l+1; m +=m) {
      boolean asc = true;
      for (int i= l; i<=r; i +=m) {
        merge(A, i, i+m-1, asc);
        asc = !asc;
      }
    }
  }

  protected void merge(ifield A, int l, int r, boolean asc) {
    int c;
    if (!asc) { c= r; r= l; l= c;}
    c = asc ? +1 : -1;
    while (l != r) {
      if (A.gt(l, r)) {
        A.move(r, l);
      }
      l += c;
    }
  }

}
