// Peter Weigel

// Quicksort
// Variante 1

package pefas.sort;

import pefas.field.ifield;

public class quicksort1 extends sort{

  protected int partition(ifield A, int l, int r) {
    int x = (l+r)/2; // Pivotelement genau aus der Mitte nehmem
    int i = l-1;
    int j = r+1;
    while (true) {
      do {j--;} while (A.gt(j, x));
      do {i++;} while (A.lt(i, x));
      if (i < j) {
        A.exchange(i, j);
        if      (i == x) { x = j; }
        else if (j == x) { x = i; }
      } else { return j; }
    }
  }

  public void sort(ifield A, int l, int r) {
    if (l < r) {
      int q = partition(A, l, r);
      sort(A, q+1, r);
      sort(A, l, q);
    }
  }

}

